/*
 *   The light cryptalk
 *   Written by Michele Lizzit
 *   13/8/2014
 *
 */

#include <LiquidCrystal.h>

#include "Config.h"

//rinominare
#define debounceDelay 1500

//i pin da 22 a 21 + 26 sono usati dal scambialettera

//codice morse
// 1 = . 2 = - 3 = finecarattere 4 = spazio

#define MORSEA "12"
#define MORSEB "2111"
#define MORSEC "2121"
#define MORSED "211"
#define MORSEE "1"
#define MORSEF "1121"
#define MORSEG "221"
#define MORSEH "1111"
#define MORSEI "11"
#define MORSEJ "1222"
#define MORSEK "212"
#define MORSEL "1211"
#define MORSEM "22"
#define MORSEN "21"
#define MORSEO "222"
#define MORSEP "1221"
#define MORSEQ "2212"
#define MORSER "121"
#define MORSES "111"
#define MORSET "2"
#define MORSEU "112"
#define MORSEV "1112"
#define MORSEW "122"
#define MORSEX "2112"
#define MORSEY "2122"
#define MORSEZ "2211"
#define MORSE0 "22222"
#define MORSE1 "12222"
#define MORSE2 "11222"
#define MORSE3 "11122"
#define MORSE4 "11112"
#define MORSE5 "11111"
#define MORSE6 "21111"
#define MORSE7 "22111"
#define MORSE8 "22211"
#define MORSE9 "22221"
//fine codice morse

int led;
int prev_led;
int tempLed;
int led_old;
unsigned long tempStart;
unsigned long tempStop;
unsigned long tempOra;
unsigned long tempLcd;
int durataSegnale;
int durataSegnale2;
int messaggio[DIMENSIONEMESSAGGIO + 1];
int caratteriLcd[41];
int posizione;
int spazio;
int finelettera;
int posLcd;
int prevNumCodice;
int numCodice;
int aggiuntaPosRotore1;
int aggiuntaPosRotore2;
int aggiuntaPosRotore3;
int led2;
int rotore1_fisso;
int rotore2_fisso;
int rotore3_fisso;

//rinominare queste variabili
int reading;
int lastButtonState;
unsigned long lastDebounceTime;
int buttonState;

const int ordineLettere2[26] = {
  10, 23, 21, 12, 3, 13, 14, 15, 8, 16, 17, 26, 25, 24, 9, 18, 1, 4, 11, 5, 7, 22, 2, 20, 19, 6
};
const int ordineLettere[27] = {
  17, 23, 5, 18, 20, 26, 21, 9, 15, 1, 19, 4, 6, 7, 8, 10, 11, 16, 25, 24, 3, 22, 2, 14, 13, 12, 17
};
const int rotore1[26] = {
  17, 24, 21, 2, 15, 19, 16, 20, 12, 11, 18, 14, 13, 26, 4, 7, 1, 5, 3, 25, 23, 8, 22, 10, 9, 6
}; //rotore D
const int rotore2[26] = {
  7,  19, 22, 16, 6, 1, 17, 9, 14, 18, 12, 5, 3, 2, 10, 4, 25, 8, 15, 24, 13, 11, 21, 23, 20, 26
}; //rotore C
const int rotore3[26] = {
  17, 14, 18, 12, 9, 2, 3, 11, 26, 10, 7, 8, 1, 24, 5, 22, 19, 15, 4, 6, 25, 23, 20, 21, 16, 13
}; //rotore S
const int riflettore[26] = {
  10, 25, 19, 12, 9, 24, 26, 18, 5, 1, 17, 4, 23, 16, 22, 14, 11, 8, 3, 21, 20, 15, 13, 6, 2, 7
};
const int shiftLettere[26] = {
  19, 14, 22, 6, 18, 7, 8, 10, 15, 11, 16, 17, 12, 13, 1, 25, 23, 20, 4, 26, 9, 2, 5, 3, 24, 21
};
const int shiftLettere_rotore3bis[26] = {
  8, 3, 11, 12, 17, 13, 22, 19, 15, 7, 10, 2, 25, 24, 6, 21, 4, 23, 20, 9, 18, 16, 14, 1, 26, 5
};
const int shiftLettere_rotore2bis[26] = {
  17, 3, 5, 20, 25, 8, 15, 24, 18, 7, 19, 4, 14, 10, 16, 1, 9, 12, 2, 23, 6, 11, 22, 26, 21, 13
};
const int shiftLettere_rotore1bis[26] = {
  22, 19, 2, 17, 25, 23, 9, 24, 10, 21, 18, 4, 14, 1, 5, 20, 3, 7, 16, 11, 8, 15, 12, 26, 6, 13
}; //fatto
const int rotore1bis[26] = {// fatto
  17, 4, 19, 15, 18, 26, 16, 22, 25, 24, 10, 9, 13, 12, 5, 7, 1, 11, 6, 8, 3, 23, 21, 2, 20, 14
}; //rotore D
const int rotore2bis[26] = { //fatto
  6, 14, 13, 16, 12, 5, 1, 18, 8, 15, 22, 11, 21, 9, 19, 4, 7, 10, 2, 25, 23, 3, 24, 20, 17, 26
}; //rotore C
const int rotore3bis[26] = {//fatto
  13, 6, 7, 19, 15, 20, 11, 12, 5, 10, 8, 4, 26, 2, 18, 25, 1, 3, 17, 23, 24, 16, 22, 14, 21, 9
}; //rotore S

int prev_clear_lcd;

LiquidCrystal lcd(48, 49, 50, 51, 52, 53);

void setup() {
  //debug
#ifdef ENABLE_DEBUG
  Serial.begin(115200);
  Serial.println(F("AVVIATO"));
#endif
  //fine debug
  
  delay(100);
  
  initLCD();

  init_scambialettera();

  init_pulsanti();
  
  posizione = 0;
  posLcd = 0;


  splashScreen();
  updateRotors();
  lcdPrintScambialettera();
}

void loop() {
  tempOra = millis();

  digitalWrite(LED, led);
  if (digitalRead(VIEW_ROTOR) == HIGH) {
    led2 = pulseIn(SEGNALE, HIGH, 1000);
  }
  
  if ((led2 >= 50) and (led2 <= 600)) {
    if ((prev_led >= 50) and (prev_led <= 600)) {
      led = HIGH;
    }
    prev_led = led2;
  }
  else {
    if (prev_led < 50) {
      led = LOW;
    }
    prev_led = led2;
  }

  if ((led2 >= 50) and (led2 <= 600)) {
    reading = HIGH;
  }
  else {
    reading = LOW;
  }

  if (reading != lastButtonState) {
    lastDebounceTime = micros();
  }
  if ((micros() - lastDebounceTime) > debounceDelay) {
    if (reading != buttonState) {
      buttonState = reading;
      if (buttonState == HIGH) {
        led = !led;
      }
    }
  }
  lastButtonState = reading;


  if ((led == HIGH) and (led_old == LOW)) {
    tempStart = tempOra;
    led_old = HIGH;
    durataSegnale2 = tempStart - tempStop;
    if ((durataSegnale2 >= MINIMOLETTERA) and (durataSegnale2 <= MASSIMOLETTERA)) {
      messaggio[posizione] = 3;
      //LCD.println("ricevuto finelettera");
      posizione++;
      //stampamessaggio();
    }
    if (durataSegnale2 >= MINIMOSPAZIO) {
      messaggio[posizione] = 4;
      //LCD.println("ricevuto spazio");
      posizione++;
      //stampamessaggio();
    }
  }
  if ((led == LOW) and (led_old == HIGH)) {
    led_old = LOW;
    tempStop = tempOra;
    durataSegnale = tempStop - tempStart;
    finelettera = 1;
    if ((durataSegnale >= MINIMOPUNTO) and (durataSegnale <= MASSIMOPUNTO)) {
      messaggio[posizione] = 1;
      //LCD.println("ricevuto punto");
      posizione++;
      //  stampamessaggio();
    }
    if ((durataSegnale >= MINIMOLINEA) and (durataSegnale <= MASSIMOLINEA)) {
      messaggio[posizione] = 2;
      //LCD.println("ricevuto linea");
      posizione++;
      //  stampamessaggio();
    }
  }
  if (((tempOra - tempStop) >= MASSIMOSPAZIO) and (finelettera == 1)) {
    messaggio[posizione] = 3;
    posizione++;
    prevNumCodice = numCodice;
    finelettera = 0;
    leggilettera();
    azzeraRotori();
    lcdPrintBuffer();
  }
  if (trovalettera() == 1) {
    leggilettera();
    lcdPrintBuffer();
  }
  if ((digitalRead(CLEAR_LCD) == LOW) and (prev_clear_lcd == HIGH)) {
    prev_clear_lcd = LOW;
    rimuoviCifre2(DIMENSIONE_BUFFER);
    posLcd = 0;
    lcdPrintBuffer();
  }
  else if ((digitalRead(CLEAR_LCD) == HIGH) and (prev_clear_lcd == LOW)) {
    prev_clear_lcd = HIGH;
  }
  if ((digitalRead(VIEW_ROTOR) == LOW)) {
    //Serial.println("r " + String(rotorChanged()) + " s " + String(scambiChanged()));
    if (rotorChanged()) {
      stampaLcd(0);
    }
    if (scambiChanged()) {
      stampaLcd(1);
    }
  }
}

void stampamessaggio() {
#ifdef ENABLE_DEBUG
  int pos = 0;
  Serial.print(F("messaggio in memoria:  '"));
  while (pos <= DIMENSIONEMESSAGGIO) {
    Serial.print(messaggio[pos]);
    Serial.print(F(","));
    pos++;
  }
  Serial.println(F("'fine"));
#endif
}

int trovalettera() {
  int pos;
  int End;
  pos = 0;
  End = 0;
  while (End == 0) {
    if ((messaggio[pos] == 3) or (messaggio[pos] == 4)) { //sostituire con invio
      return 1;
      End = 1;
    }
    if (pos == DIMENSIONEMESSAGGIO) {
      End = 1;
      return 0;
    }
    else {
      pos++;
    }
  }
}

void rimuoviUltimaCifra() {
  int pos;
  int End;
  pos = 0;
  End = 0;
  while (End == 0) {
    if ((pos + 1) == DIMENSIONEMESSAGGIO) {
      End = 1;
    }
    messaggio[pos] = messaggio[pos + 1];
    pos++;
  }
  messaggio[DIMENSIONEMESSAGGIO] = 0;
  posizione = posizione - 1;
  if (posizione <= 0) {
    posizione = 0;
  }
}

void rimuoviCifre(int num) {
  int numCifre = 0;
  while (numCifre < num) {
    rimuoviUltimaCifra();
    numCifre++;
  }
}

void rimuoviCifre2(int num) {
  int numCifre = 0;
  while (numCifre < num) {
    rimuoviUltimaCifra2();
    numCifre++;
  }
}

void leggilettera() {
  String carattere;
  int pos2 = 0;
  int pos3 = 0;
  while ((messaggio[pos2] != 3) and (messaggio[pos2] != 4)) {
    carattere += messaggio[pos2];
    pos2++;
  }
  if (messaggio[pos2] == 4) {
    //carattere += 32; //32 = spazio
    spazio = 1;
    pos2++;
  }
  if (messaggio[pos2] == 3) {
    pos2++;
  }
  rimuoviCifre(pos2);
  if (carattere == MORSEA) {
    stampacarattere(1);
  }
  else if (carattere == MORSEB) {
    stampacarattere(2);
  }
  else if (carattere == MORSEC) {
    stampacarattere(3);
  }
  else if (carattere == MORSED) {
    stampacarattere(4);
  }
  else if (carattere == MORSEE) {
    stampacarattere(5);
  }
  else if (carattere == MORSEF) {
    stampacarattere(6);
  }
  else if (carattere == MORSEG) {
    stampacarattere(7);
  }
  else if (carattere == MORSEH) {
    stampacarattere(8);
  }
  else if (carattere == MORSEI) {
    stampacarattere(9);
  }
  else if (carattere == MORSEJ) {
    stampacarattere(10);
  }
  else if (carattere == MORSEK) {
    stampacarattere(11);
  }
  else if (carattere == MORSEL) {
    stampacarattere(12);
  }
  else if (carattere == MORSEM) {
    stampacarattere(13);
  }
  else if (carattere == MORSEN) {
    stampacarattere(14);
  }
  else if (carattere == MORSEO) {
    stampacarattere(15);
  }
  else if (carattere == MORSEP) {
    stampacarattere(16);
  }
  else if (carattere == MORSEQ) {
    stampacarattere(17);
  }
  else if (carattere == MORSER) {
    stampacarattere(18);
  }
  else if (carattere == MORSES) {
    stampacarattere(19);
  }
  else if (carattere == MORSET) {
    stampacarattere(20);
  }
  else if (carattere == MORSEU) {
    stampacarattere(21);
  }
  else if (carattere == MORSEV) {
    stampacarattere(22);
  }
  else if (carattere == MORSEW) {
    stampacarattere(23);
  }
  else if (carattere == MORSEX) {
    stampacarattere(24);
  }
  else if (carattere == MORSEY) {
    stampacarattere(25);
  }
  else if (carattere == MORSEZ) {
    stampacarattere(26);
  }
  else if (carattere == MORSE0) {
    stampacarattere(27);
  }
  else if (carattere == MORSE1) {
    stampacarattere(28);
  }
  else if (carattere == MORSE2) {
    stampacarattere(29);
  }
  else if (carattere == MORSE3) {
    stampacarattere(30);
  }
  else if (carattere == MORSE4) {
    stampacarattere(31);
  }
  else if (carattere == MORSE5) {
    stampacarattere(32);
  }
  else if (carattere == MORSE6) {
    stampacarattere(33);
  }
  else if (carattere == MORSE7) {
    stampacarattere(34);
  }
  else if (carattere == MORSE8) {
    stampacarattere(35);
  }
  else if (carattere == MORSE9) {
    stampacarattere(36);
  }
  if (spazio == 1) {
    spazio = 0;
    stampacarattere(37);
  }
}

void stampacarattere(int carattereLcd) {
  if (digitalRead(CRIPTATO) == LOW) {
    carattereLcd = calcolaLettera(carattereLcd);
  }
  carattereLcd = letteraAscii(carattereLcd);
  if (posLcd >= (DIMENSIONE_BUFFER - 1)) {
    rimuoviUltimaCifra2();
    caratteriLcd[posLcd] = carattereLcd;
  }
  else if (((posLcd == 0) && (carattereLcd != 32)) || ((posLcd != 0))) {
    caratteriLcd[posLcd] = carattereLcd;
    posLcd++;
  }
}
void stampaLcd() {
  stampaLcd(0);
}

void stampaLcd(int update_scambi) {
  if (digitalRead(VIEW_ROTOR) == LOW) {
    if (rotorChanged()) {
      updateRotors();
    }
    if (update_scambi == 1) {
      lcdPrintScambialettera();
    }
  }
  else {
    lcdPrintBuffer();
  }

}

void rimuoviUltimaCifra2() {
  int pos;
  int End;
  pos = 0;
  End = 0;
  while (End == 0) {
    if ((pos + 1) == DIMENSIONE_BUFFER) {
      End = 1;
    }
    caratteriLcd[pos] = caratteriLcd[pos + 1];
    pos++;
  }
  caratteriLcd[DIMENSIONE_BUFFER] = 0;
  posizione = posizione - 1;
  if (posizione <= 0) {
    posizione = 0;
  }
}



