/*
 *   The light cryptalk
 *   Written by Michele Lizzit
 *   13/8/2014
 *
 */


#include <KeyboardController_MOD.h>
#include <LiquidCrystal.h>
//#include <Time.h>
#include "Config.h"

//i pin da 22 a 21 + 26 sono usati dal scambialettera

int x;
const int ordineLettere2[26] = {
  10, 23, 21, 12, 3, 13, 14, 15, 8, 16, 17, 26, 25, 24, 9, 18, 1, 4, 11, 5, 7, 22, 2, 20, 19, 6
};
const int ordineLettere[27] = {
  17, 23, 5, 18, 20, 26, 21, 9, 15, 1, 19, 4, 6, 7, 8, 10, 11, 16, 25, 24, 3, 22, 2, 14, 13, 12, 17
};
const int rotore1[26] = {
  17, 24, 21, 2, 15, 19, 16, 20, 12, 11, 18, 14, 13, 26, 4, 7, 1, 5, 3, 25, 23, 8, 22, 10, 9, 6
}; //rotore D
const int rotore2[26] = {
  7,  19, 22, 16, 6, 1, 17, 9, 14, 18, 12, 5, 3, 2, 10, 4, 25, 8, 15, 24, 13, 11, 21, 23, 20, 26
}; //rotore C
const int rotore3[26] = {
  17, 14, 18, 12, 9, 2, 3, 11, 26, 10, 7, 8, 1, 24, 5, 22, 19, 15, 4, 6, 25, 23, 20, 21, 16, 13
}; //rotore S
const int riflettore[26] = {
  10, 25, 19, 12, 9, 24, 26, 18, 5, 1, 17, 4, 23, 16, 22, 14, 11, 8, 3, 21, 20, 15, 13, 6, 2, 7
};
const int shiftLettere[26] = {
  19, 14, 22, 6, 18, 7, 8, 10, 15, 11, 16, 17, 12, 13, 1, 25, 23, 20, 4, 26, 9, 2, 5, 3, 24, 21
};
const int shiftLettere_rotore3bis[26] = {
  8, 3, 11, 12, 17, 13, 22, 19, 15, 7, 10, 2, 25, 24, 6, 21, 4, 23, 20, 9, 18, 16, 14, 1, 26, 5
};
const int shiftLettere_rotore2bis[26] = {
  17, 3, 5, 20, 25, 8, 15, 24, 18, 7, 19, 4, 14, 10, 16, 1, 9, 12, 2, 23, 6, 11, 22, 26, 21, 13
};
const int shiftLettere_rotore1bis[26] = {
  22, 19, 2, 17, 25, 23, 9, 24, 10, 21, 18, 4, 14, 1, 5, 20, 3, 7, 16, 11, 8, 15, 12, 26, 6, 13
}; //fatto
const int rotore1bis[26] = {// fatto
  17, 4, 19, 15, 18, 26, 16, 22, 25, 24, 10, 9, 13, 12, 5, 7, 1, 11, 6, 8, 3, 23, 21, 2, 20, 14
}; //rotore D
const int rotore2bis[26] = { //fatto
  6, 14, 13, 16, 12, 5, 1, 18, 8, 15, 22, 11, 21, 9, 19, 4, 7, 10, 2, 25, 23, 3, 24, 20, 17, 26
}; //rotore C
const int rotore3bis[26] = {//fatto
  13, 6, 7, 19, 15, 20, 11, 12, 5, 10, 8, 4, 26, 2, 18, 25, 1, 3, 17, 23, 24, 16, 22, 14, 21, 9
}; //rotore S
int messaggio[DIMENSIONEMESSAGGIO + 1];
int posizione;
int aggiuntaPosRotore1;
int aggiuntaPosRotore2;
int aggiuntaPosRotore3;
int tastiera_connessa;
int prev_butt_mostra_rotori;
USBHost usb;
KeyboardController keyboard(usb);
LiquidCrystal lcd(48, 49, 50, 51, 52, 53);
//carattere tx
byte tx[8] = {
  0b11111,
  0b00100,
  0b00100,
  0b10101,
  0b01010,
  0b00100,
  0b01010,
  0b10001
};
byte ok[8] = {
  0b00000,
  0b00000,
  0b00001,
  0b00001,
  0b10010,
  0b01010,
  0b00100,
  0b00100
};
/*
byte tastiera[8] = {
 0b00100,
 0b00010,
 0b00100,
 0b01000,
 0b11101,
 0b01010,
 0b10111,
 0b01010
 };*/
byte tastiera[8] = {
  0b00100,
  0b00101,
  0b00101,
  0b10101,
  0b10110,
  0b01100,
  0b00100,
  0b00000
};

int rotore1_fisso;
int rotore2_fisso;
int rotore3_fisso;

void setup() {
  //debug
#ifdef ENABLE_DEBUG
  Serial.begin(115200);
  Serial.println("AVVIATO");
#endif
  //fine debug
  
  delay(100);
  
  initLCD();
  
  
  pinMode(BUTT_MOSTRA_ROTORI, INPUT_PULLUP);
  pinMode(LED, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(BUZZER, OUTPUT);
  pinMode(CRIPTATO, INPUT_PULLUP);
  digitalWrite(LED, LOW);
  digitalWrite(LED2, LOW);
  digitalWrite(BUZZER, LOW);
  posizione = 0;
  tastiera_connessa = isKeyboardConnected();

  rotore1_fisso = posRotore1();
  rotore2_fisso = posRotore2();
  rotore3_fisso = posRotore3();
  
  init_scambialettera();
  
  splashScreen();
  lcdPrintLastLine(0);
  updateRotors();
  lcdPrintScambialettera();
}

void scrivilcd(int trasmettere, int printScambi = 0) {
  if ((digitalRead(BUTT_MOSTRA_ROTORI) == 1)) {
    int carattere;
    int pos = 0;
    //lcd.clear();
    lcd.setCursor(0, 0);
    while (pos <= (LCD_COLONNE - 1)) {
      carattere = messaggio[pos];
      if (carattere == 0) {
        carattere = 32;
      }
      lcd.write(carattere);
      pos++;
    }
    lcdPrintLastLine(trasmettere);
  }
  else {
    updateRotors();
    if (printScambi == 1) {
      lcdPrintScambialettera();
    }
    
    lcdPrintLastLine(trasmettere);
  }
}

void loop() {
  if (trovainvio() == 1) {
    digitalWrite(LED2, LOW);
    scrivilcd(1);
    while (trovainvio() == 1) {
      trasmetti(messaggio[0]);
      rimuoviUltimaCifra();
      scrivilcd(1);
    }
  }
  azzeraRotori();

  if (digitalRead(BUTT_MOSTRA_ROTORI) == 1) {
    if (prev_butt_mostra_rotori == 1) {
      prev_butt_mostra_rotori = 0;
      scrivilcd(0,1);
    }
    digitalWrite(LED2, HIGH);
    if (!isKeyboardConnected()) {
      digitalWrite(LED2, LOW);
      if (tastiera_connessa == 1) {
        tastiera_connessa = 0;
        scrivilcd(0);
      }
      //delay(2); //attende un p quando la tastiera non e connessa per vedere il led spento
    }
    else {
      if (tastiera_connessa == 0) {
        tastiera_connessa = 1;
        scrivilcd(0);
      }
      digitalWrite(LED2, HIGH);
    }
  }
  else {
    if (rotorChanged()) {
      scrivilcd(0);
      //scriviRotori();
      delay(30);
    }
    if (scambiChanged()) {
      scrivilcd(0,1);
    }
    if (prev_butt_mostra_rotori == 0) {
      prev_butt_mostra_rotori = 1;
      scrivilcd(0,1);
    }
  }
}


int trovainvio() {
  int pos;
  int End;
  pos = 0;
  End = 0;
  while (End == 0) {
    if (messaggio[pos] == CARATTEREINVIO) { //sostituire con invio
      return 1;
      End = 1;
    }
    if (pos == DIMENSIONEMESSAGGIO) {
      End = 1;
      return 0;
    }
    else {
      pos++;
    }
  }
}

void rimuoviUltimaCifra() {
  int pos;
  int End;
  pos = 0;
  End = 0;
  while (End == 0) {
    if ((pos + 1) == DIMENSIONEMESSAGGIO) {
      End = 1;
    }
    messaggio[pos] = messaggio[pos + 1];
    pos++;
  }
  messaggio[DIMENSIONEMESSAGGIO] = 0;
  posizione = posizione - 1;
}


void keyPressed() {
  x = keyboard.getKey();
  if ((posizione < (DIMENSIONEMESSAGGIO)) && (!nonMorseChar(x))) { //se c'è spazio per scrivere e il carattere è valido
    if (keyboard.getOemKey() == 42) { //se è backspace
      if (posizione >= 1) { //se ci sono caratteri da cancellare
        messaggio[posizione - 1] = 0; //cancella l'ultimo carattere
        posizione--;
      }
    }
    else {
      if ((x != 0) && (x != 32)) {
        messaggio[posizione] = x;
        posizione++;
      }
      else if ((x == 32) && (posizione > 0)) {//il primo carattere non deve essere spazione e non devono essere 2 spazi coonsecutivi
        if ((messaggio[posizione - 1] != 32)) {
          messaggio[posizione] = x;
          posizione++;
        }
      }
    }
  }
  else if (x == CARATTEREINVIO) {
    messaggio[DIMENSIONEMESSAGGIO] = x;
    posizione++;
  }
  else if (!nonMorseChar(x)) {
    if (keyboard.getOemKey() == 42) { //se è backspace
      if (posizione >= 1) { //se ci sono caratteri da cancellare
        messaggio[posizione - 1] = 0; //cancella l'ultimo carattere
        posizione--;
      }
    }
  }
  #ifdef ENABLE_DEBUG
  else {
    Serial.println("CARATTERE NON VALIDO: " + String(x));
  }
  #endif
  scrivilcd(0,0);
}


void lcdPrintScambialettera() {
  lcd.setCursor(0,3);
  String scambi = lettereScambiate(NUM_SCAMBI_VISUALIZZATI);
  lcd.print(scambi);
  for (int i = 0; i < (20 - scambi.length()); i++) {
    lcd.print(" ");
  }
}

void lcdPrintLastLine(int trasmettere) {
  lcd.setCursor(0, (LCD_RIGHE - 2));
  if (trasmettere == 1) {
    lcd.print("Transmitting");
  }
  else {
    lcd.print("Ready       ");
  }
  
  lcd.setCursor((LCD_COLONNE - 2), (LCD_RIGHE - 2));
  if (tastiera_connessa == 1) {
    lcd.write((byte)2);
  }
  else {
    lcd.print(" ");
  }
  
  lcd.setCursor((LCD_COLONNE - 1), (LCD_RIGHE - 2));
  if (trasmettere == 1) {
    lcd.write((byte)0);
  }
  else {
    lcd.write((byte)1);
  }
}
